// Projet : Hakken Roboto
// Robot suiveur de ligne avec détection d'obstacle composé de :
// Grove Driver  TB6612FNG, 2 capteurs Grove "Line Finder", 1 capteur Grove Ultrasonic Sensor, 1 Grove Switch
// Programme réalisé par M.DEVILLE le 27/10/2020

#include "Ultrasonic.h"
long RangeInCentimeters;   //déclaration d'une variable de type long
Ultrasonic sensor = 7;   // connected to digital pin 7

#include "Grove_Motor_Driver_TB6612FNG.h" //
#include <Wire.h>
MotorDriver motor;  // Initialisation des moteurs

int CapteurDroit  =  2;    // connected to digital pin 2
int CapteurGauche =  3;    // connected to digital pin 3

const int switchPin = 4;     // connected to digital pin 4
int switchState = 0;         // variable for reading the pushbutton status
 
void setup() 
{
    pinMode(switchPin, INPUT);
    
    // join I2C bus (I2Cdev library doesn't do this automatically)
    Wire.begin();
    Serial.begin(9600);
    motor.init();
  
  pinMode (CapteurDroit,INPUT); // initialise le port digital 2 comme une ENTREE
  pinMode (CapteurGauche, INPUT);  // initialise le port digital 3 comme une ENTREE
  Serial.println("Setup Done"); // signaler que l'initialisation s'est bien déroulée
}

void loop() 
{
    switchState = digitalRead(switchPin);   // read the state of the switch value:

    Serial.print("La distance avec l'obstacle est :  ");
    RangeInCentimeters = sensor.MeasureInCentimeters();
    Serial.print(RangeInCentimeters);
    Serial.println(" cm");
    delay(100);
    
    //  S'il y a du NOIR à droite et à Gauche & obstacle à une distance >= 10cm & Switch ON,  avancer tout droit 
    if (switchState == HIGH && digitalRead(CapteurDroit) == HIGH  && RangeInCentimeters >= 10 && digitalRead(CapteurGauche) == HIGH)  
    {
    // drive 2 dc motors at speed=255, clockwise
    Serial.println("Avancer run at speed=255");
    motor.dcMotorRun(MOTOR_CHA, 255);
    motor.dcMotorRun(MOTOR_CHB, 255);
    delay(100);
     }
    else if(switchState == HIGH && RangeInCentimeters >= 10 && digitalRead(CapteurDroit) == HIGH  && digitalRead(CapteurGauche) == LOW) 
    {
    // drive 2 dc motors at speed=255, clockwise
    Serial.println("Tourner à gauche run at speed=255");
    motor.dcMotorRun(MOTOR_CHA, 255);
    motor.dcMotorRun(MOTOR_CHB, 0);
    delay(100);
    }
    else if(switchState == HIGH && RangeInCentimeters >= 10 && digitalRead(CapteurDroit) == LOW  && digitalRead(CapteurGauche) == HIGH)          
    {
    // drive 2 dc motors at speed=255, clockwise
    Serial.println("Tourner à droite at speed=255");
    motor.dcMotorRun(MOTOR_CHA, 0);
    motor.dcMotorRun(MOTOR_CHB, 255);
    delay(100);
    }
    else
    {
    Serial.println ("Stopper");
    Serial.print(RangeInCentimeters);
    Serial.println(" cm");
    motor.dcMotorStop(MOTOR_CHA);
    motor.dcMotorStop(MOTOR_CHB);
    delay(100);
    }
}
